#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Path = __importStar(require("path"));
const vscode_languageserver_1 = require("vscode-languageserver");
const web_tree_sitter_1 = __importDefault(require("web-tree-sitter"));
const connection = vscode_languageserver_1.createConnection(vscode_languageserver_1.ProposedFeatures.all);
connection.onDidChangeConfiguration(params => undefined);
connection.onInitialize((params) => __awaiter(this, void 0, void 0, function* () {
    return new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
        try {
            connection.console.info("Activating tree-sitter...");
            yield web_tree_sitter_1.default.init();
            const absolute = Path.join(__dirname, "tree-sitter-elm.wasm");
            const pathToWasm = Path.relative(process.cwd(), absolute);
            const language = yield web_tree_sitter_1.default.Language.load(pathToWasm);
            const parser = new web_tree_sitter_1.default();
            parser.setLanguage(language);
            const { Server } = yield Promise.resolve().then(() => __importStar(require("./server")));
            const server = new Server(connection, params, parser);
            resolve(server.capabilities);
        }
        catch (error) {
            connection.console.error(error.stack);
            reject();
        }
    }));
}));
// Listen on the connection
connection.listen();
//# sourceMappingURL=index.js.map