import { IConnection } from "vscode-languageserver";
import { URI } from "vscode-uri";
import { TextDocumentEvents } from "../../util/textDocumentEvents";
import { ElmAnalyseDiagnostics } from "./elmAnalyseDiagnostics";
import { ElmMakeDiagnostics } from "./elmMakeDiagnostics";
export interface IElmIssueRegion {
    start: {
        line: number;
        column: number;
    };
    end: {
        line: number;
        column: number;
    };
}
export interface IElmIssue {
    tag: string;
    overview: string;
    subregion: string;
    details: string;
    region: IElmIssueRegion;
    type: string;
    file: string;
}
export declare class DiagnosticsProvider {
    private connection;
    private elmWorkspaceFolder;
    private events;
    private elmMakeDiagnostics;
    private elmAnalyseDiagnostics;
    private currentDiagnostics;
    constructor(connection: IConnection, elmWorkspaceFolder: URI, events: TextDocumentEvents, elmAnalyse: ElmAnalyseDiagnostics, elmMake: ElmMakeDiagnostics);
    private newElmAnalyseDiagnostics;
    private sendDiagnostics;
    private getDiagnosticsOnChange;
    private getDiagnosticsOnSaveOrOpen;
    private getDiagnostics;
}
