"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const events_1 = require("events");
const vscode_uri_1 = require("vscode-uri");
class DocumentEvents extends events_1.EventEmitter {
    constructor(connection, elmWorkspace) {
        super();
        connection.onDidChangeTextDocument(event => this.emitForWorkspace(event, elmWorkspace, "change"));
        connection.onDidCloseTextDocument(event => this.emitForWorkspace(event, elmWorkspace, "close"));
        connection.onDidOpenTextDocument(event => this.emitForWorkspace(event, elmWorkspace, "open"));
        connection.onDidSaveTextDocument(event => this.emitForWorkspace(event, elmWorkspace, "save"));
    }
    emitForWorkspace(event, elmWorkspace, eventType) {
        const documentUri = vscode_uri_1.URI.parse(event.textDocument.uri);
        if (documentUri.toString().startsWith(elmWorkspace.toString())) {
            this.emit(eventType, event);
        }
    }
}
exports.DocumentEvents = DocumentEvents;
//# sourceMappingURL=documentEvents.js.map