"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Settings {
    constructor(capabilities, initializationOptions) {
        this.capabilities = capabilities;
        this.initializationOptions = initializationOptions;
        this.fallbackClientSettings = {
            elmFormatPath: "elm-format",
            elmPath: "elm",
            elmTestPath: "elm-test",
        };
    }
    getSettings(connection) {
        // Allow falling back to the preset params
        const defaultSettings = Object.assign({}, this.fallbackClientSettings, this.initializationOptions);
        const supportsConfig = this.capabilities &&
            this.capabilities.workspace &&
            this.capabilities.workspace.configuration;
        if (!supportsConfig) {
            return Promise.resolve(defaultSettings);
        }
        return Promise.resolve(connection.workspace
            .getConfiguration({ section: "elmLS" })
            .then(settings => Object.assign(Object.assign({}, defaultSettings, settings))));
    }
}
exports.Settings = Settings;
//# sourceMappingURL=settings.js.map